/* rec_havail.c -- find where a record belongs in a hashed file */
#include "rec_io.h"

long rec_havail(fd, keybuf, buf, hashfn)
	rec_fd fd;			/* hashed file */
	data_ptr keybuf;	/* record key to find */
	data_ptr buf;		/* buffer for found record */
	long (*hashfn)();	/* hash lookup function */
	{
	long nrecs;			/* number of records in file */
	long ntry;
	long i;

	nrecs = rec_nrecs(fd);
	i = (*hashfn)(keybuf);
	for (ntry = 0; ntry < nrecs; ++ntry)
		{
		if (!rec_get(fd, buf, i))
			return (REC_ERROR);
		if (*(char *)buf == REC_AVAIL || *(char *)buf == REC_DELET)
			return (i);
		i = IMOD(i + 1, nrecs);
		}
	return (REC_FULL);
	}
